// Toolbar identification strings
const TOOLBAR_NAME = "Accessibar Toolbar";
const TOOLBAR_ID   = "accessibar";

function uninstall(url)
{
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
    var confirmUninstall = confirm("Do you want to uninstall " + TOOLBAR_NAME+ " ?" );
    
    if (!confirmUninstall) // user choose to cancel
    	return;
    
    // remove the toolbar
    var myToolBar = document.getElementById(TOOLBAR_ID);
    myToolBar.parentNode.removeChild(myToolBar);
    
    // remove the view menu entry
    var myViewMenuEntry = document.getElementById("view_"+TOOLBAR_ID+"_menuitem");
    myViewMenuEntry.parentNode.removeChild(myViewMenuEntry);
    
    //remove the overlay entry in overlays.rdf
    
    var CONTAINER_NAME  = "chrome://navigator/content/navigator.xul";
    var NODE_NAME       = "chrome://"+TOOLBAR_ID+"/content/"+TOOLBAR_ID+"Overlay.xul";
    
    var dirServ = Components.classes['@mozilla.org/file/directory_service;1'].createInstance();
    dirServ = dirServ.QueryInterface(Components.interfaces.nsIProperties);
    var processDir = dirServ.get("AChrom", Components.interfaces.nsIFile);
    processDir.append("overlayinfo");
    processDir.append("navigator");
    processDir.append("content");
    processDir.append("overlays.rdf");
    
    removeRDFContainer(processDir, CONTAINER_NAME, NODE_NAME);
    
    // remove chrome.rdf entries
    
    CONTAINER_NAME = 'urn:mozilla:package:root';
    NODE_NAME = 'urn:mozilla:package:accessibar';
    
    processDir = dirServ.get("AChrom", Components.interfaces.nsIFile);
    processDir.append("chrome.rdf");
    
    // removeRDFDescription(processDir, CONTAINER_NAME, NODE_NAME);
    removeRDFContainer(processDir, CONTAINER_NAME, NODE_NAME);
    
    // remove the installed-chrome.txt entries - thanks to HJ for the code
    processDir = dirServ.get("AChrom", Components.interfaces.nsIFile);
    processDir.append("installed-chrome.txt");
    
    var entries = readFrom(processDir);
    entries = entries.replace(new RegExp('[^\\n\\r]+'+"resource:/chrome/"+TOOLBAR_ID+".jar!/content/"+'[\\n\\r]+', 'g'), '');
    writeTo(processDir, entries);
    
    //remove the .jar file
    processDir = dirServ.get("AChrom", Components.interfaces.nsIFile);
    processDir.append("accessibar.jar");
    //(false) because we don't want to recurse
    processDir.remove(false);
}

function removeRDFContainer(fileRef, containerName, nodeName)
{
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
    var C                       = Components;
    const RDF_SRVC_PROG_ID      = '@mozilla.org/rdf/rdf-service;1';
    const RDF_CONTAINER_PROG_ID = '@mozilla.org/rdf/container;1';
    const RDF_DS_PROG_ID        = '@mozilla.org/rdf/datasource;1?name=xml-datasource';
    
    if (!fileRef.exists()) {
        return;
    }
    
    var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    
    // Interface change - ns7 (mozilla 1.0) needs nsIIOService, latter (mozilla 1.2) needs nsIFileProtocolHandler
    if(Components.interfaces.nsIFileProtocolHandler){
        var fileHandler = ioService.getProtocolHandler("file").QueryInterface(Components.interfaces.nsIFileProtocolHandler);
        var myFileUrl = fileHandler.getURLSpecFromFile(fileRef);
        } else {
        var myFileUrl = ioService.getURLSpecFromFile(fileRef);
    }
    
    try {
        var rdf   = C.classes
        [RDF_SRVC_PROG_ID].getService(C.interfaces.nsIRDFService);
        
        var ds    = rdf.GetDataSource(myFileUrl);
        
        var rem   = ds.QueryInterface(C.interfaces.nsIRDFRemoteDataSource);
        if (!rem.loaded) {
            rdf.UnregisterDataSource(ds);
            ds        = C.classes[RDF_DS_PROG_ID].
            getService(C.interfaces.nsIRDFDataSource);
            rem       = ds.QueryInterface(C.interfaces.nsIRDFRemoteDataSource);
            rem.Init(myFileUrl);
        }
        rem.Refresh(true);
        var rs  = rdf.GetResource(containerName);
        var container = C.classes[RDF_CONTAINER_PROG_ID].
        getService(C.interfaces.nsIRDFContainer);
        container.Init(rem, rs);
        
        var el = rdf.GetLiteral(nodeName); // remove if it's a literal
        container.RemoveElement(el, true);
        el = rdf.GetResource(nodeName); // remove it it's a resource
        container.RemoveElement(el, true);
        rem.Flush();
        rem.Refresh(true);
        } catch (e) {
        return;
    }
}

function readFrom(aFile)
{
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
    var stream = Components.classes['@mozilla.org/network/file-input-stream;1'].createInstance(Components.interfaces.nsIFileInputStream);
    stream.init(aFile, 1, 0, false); // open as "read only"
    
    var scriptableStream = Components.classes['@mozilla.org/scriptableinputstream;1'].createInstance(Components.interfaces.nsIScriptableInputStream);
    scriptableStream.init(stream);
    
    var fileSize = scriptableStream.available();
    var fileContents = scriptableStream.read(fileSize);
    
    scriptableStream.close();
    stream.close();
    
    return fileContents;
}

function writeTo(aFile, aContent)
{
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
    if (aFile.exists()) aFile.remove(true);
    aFile.create(aFile.NORMAL_FILE_TYPE, 0666);
    
    var stream = Components.classes['@mozilla.org/network/file-output-stream;1'].createInstance(Components.interfaces.nsIFileOutputStream);
    stream.init(aFile, 2, 0x200, false); // open as "write only"
    
    stream.write(aContent, aContent.length);
    
    stream.close();
}